<?php

	global $slider_array_default, $gsp_option_name, $slide_transitions_object, $main_url;
	$main_url =  admin_url() . 'admin.php?page=gsp_slider';

	include('slider-transitions.php');
	$slide_transitions_object = json_decode($slide_transitions_json);


	$gsp_option_name = 'gsp-item-';
	$slider_array_default = array(

		'slider_title' => '',
		'transitions' => '',
		'images' => '',

	);
	
	function gsp_sanitize_input( $input ) {
		if(is_array($input)){		
			$new_input = array();	
			foreach ( $input as $key => $val ) {
				$new_input[ $key ] = (is_array($val)?gsp_sanitize_input($val):sanitize_text_field( $val ));
			}			
		}else{
			$new_input = sanitize_text_field($input);			
			if(stripos($new_input, '@') && is_email($new_input)){
				$new_input = sanitize_email($new_input);
			}
			if(stripos($new_input, 'http') || wp_http_validate_url($new_input)){
				$new_input = esc_url($new_input);
			}			
		}	
		return $new_input;
	}	


	if (!function_exists('gsp_menu')) {
		function gsp_menu()
		{

			add_menu_page('Gulri Slider', 'Gulri Slider', 'manage_options', 'gsp_slider', 'gsp_slider_admin');


			if (!function_exists('gsp_slider_admin')) {
				function gsp_slider_admin()
				{
					include_once('sliders-admin.php');
				}
			}
		}
	}


	if (!function_exists('pre')) {
		function pre($data)
		{
			if (isset($_GET['debug'])) {
				pree($data);
			}
		}
	}
	if (!function_exists('pree')) {
		function pree($data)
		{
			echo '<pre>';
			print_r($data);
			echo '</pre>';
		}
	}
	if (!function_exists("fetch_array")) {
		function fetch_array($result)
		{

			return json_decode(json_encode($result), true);
		}
	}

	if (!function_exists('gsp_scripts_loader')) {
		function gsp_scripts_loader()
		{
			
			if(is_admin() && isset($_GET['page']) && $_GET['page']=='gsp_slider'){
				wp_enqueue_media();
				wp_enqueue_style('gsp-boostrap-style', plugins_url('/css/bootstrap.min.css', dirname(__FILE__)));
				wp_enqueue_script('gsp-fontawesome-script', 'https://kit.fontawesome.com/2439732f7d.js', array('jquery'), '1.0', true);
				wp_enqueue_script('gsp-popper-script', plugins_url('/js/popper.min.js', dirname(__FILE__)), array('jquery'), '1.0', true);
				wp_enqueue_script('gsp-boostrap-script', plugins_url('/js/bootstrap.min.js', dirname(__FILE__)), array('jquery'), '1.0', true);
				wp_enqueue_style('gsp-custom-styles', plugins_url('/css/gsp-custom-style.css', dirname(__FILE__)), array(), date('his'));			
				wp_enqueue_script('gsp-custom-scripts', plugins_url('/js/gsp-custom-script.js', dirname(__FILE__)), array('jquery'), time(), true);
				wp_localize_script('gsp-custom-scripts', 'slider_obj', array('ajax_url' => admin_url( 'admin-ajax.php' )));
			}
			

		}
		add_action('wp_enqueue_scripts', 'gsp_scripts_loader');

		if (is_admin() && isset($_GET['page']) && $_GET['page'] == 'gsp_slider') {
			add_action('admin_enqueue_scripts', 'gsp_scripts_loader');
		}
	}

//	pree(get_option('custom_slider-1'));exit;

	add_shortcode('GSLIDER', 'slider_display');


	if(!function_exists('slider_get_table_rows_html')){

		function slider_get_table_rows_html(){
			global $main_url, $wpdb, $gsp_option_name, $slide_transitions_object;

			$slider_results = $wpdb->get_results("SELECT * FROM {$wpdb->prefix}options WHERE option_name LIKE '" . $gsp_option_name . "%'", OBJECT);


			if (!empty($slider_results)) {

				$counter = 1;

				usort($slider_results, function ($a, $b){

				    $option_a = $a->option_name;
				    $option_b = $b->option_name;

				    $option_a = explode('-', $option_a);
				    $option_b = explode('-', $option_b);

                    $option_a = $option_a[1];
                    $option_b = $option_b[1];

				    return ($a > $b) ? -1 : 1;

                });

//				pree($slider_results);exit;

				foreach ($slider_results as $key => $value) {
					# code...
					$custom_slider = $value->option_value;
					$custom_slider = unserialize($custom_slider);
					$custom_slider_transitions = $custom_slider['transitions'];
					$custom_slider_id = $value->option_name;
					$option_id = $value->option_id;


					?>
					<tr data-option="<?php echo $option_id ?>">


						<td>

                            <div class="slider_title_view "><?php echo $custom_slider['slider_title'] ?></div>
                            <input type="text" class="slider_title_input d-none" value="<?php echo $custom_slider['slider_title'] ?>" data-option=""/>

                        </td>

						<td style="width: 300px" >

							<div class="row slider_images_row">

								<?php

								if(!empty($custom_slider['images'])){
//								    pree($custom_slider['images']);exit;
									foreach ($custom_slider['images'] as $image_index => $image){
										$image_url = wp_get_attachment_image_src($image);
										$image_url = is_array($image_url) ? $image_url : array();
										$display = $image_index > 2 ? 'd-none' : '';
										$data_show = $image_index > 2 ? 'show_more' : '';
										if($image_index > 8){continue;};




										echo '<div class="col-4 mb-2 slider_image_thumb '.$display.'" data-show="'.$data_show.'">

												    <input type="hidden" name="attachment_ids['.$option_id.'][]" value="'.$image.'"/>
												   <img class="img-thumbnail slider_table_images" src="'.current($image_url).'" width="100px" height="100px"/>
												
											   </div>';

									}


								}else{


									echo '<div class="col-4 mb-2 " data-show="" >

												    <input type="hidden" name="attachment_ids['.$option_id.'][]" value=""/>
												   <img title="'.__('Click here to add slider images').'" class="img-thumbnail slider_table_images" src="'.plugins_url('/img/gsp_slider.jpg', dirname(__FILE__)).'" width="100px" height="100px"/>
												
											   </div>';


								}

								?>

							</div>

                            <?php
                            $show_more_display = 'd-none';

                            if(sizeof($custom_slider['images']) > 3){

                                $show_more_display = '';

                            }

                            echo '<div class="col-12 mb-2 text-primary slider_show_more '.$show_more_display.'" data-toggle="show" style="text-align: center"><i class="fa fa-2x fa-grip-horizontal slider_show_more"></i> </div>';


                            ?>

						</td>

						<td style="width: 250px;">

							<?php
							$colum = '';

							if (!empty($custom_slider_transitions)) {

								$value = current($custom_slider_transitions);

								$string = str_replace('\\', '', $value);

								$transition = json_decode($string, true);

								$colum = $transition['key'];

							} else {

								$colum =  'No transition selected';
							}



							?>


							<div class="dropdown slider_table_transition_dropdown">
								<button type="button" class="btn btn btn-sm btn-default dropdown-toggle " id="dropdownMenuButton" data-toggle="" aria-haspopup="true" aria-expanded="false">
									<span class="slider_table_transition_name"><?php echo $colum ?></span>
								</button>
								<div class="dropdown-menu" aria-labelledby="dropdownMenuButton">

									<?php if(!empty($slide_transitions_object)){


										foreach ($slide_transitions_object as $transition_index => $transition_obj){

											?>

											<a class="dropdown-item slider_table_transition_item" data-id="<?php echo $transition_index ?>" data-option="<?php echo $option_id ?>"><?php echo $transition_obj->key ?></a>


											<?php

										}

									}?>


								</div>
							</div>


						</td>
						<td>
							[GSLIDER id="<?php echo $option_id ?>"]
						</td>
						<td>
							<a href="<?php echo $main_url; ?>&edit_slider=<?php echo $option_id ?>" class="btn btn-sm btn-secondary"><?php _e('Edit'); ?></a>
							<a href="<?php echo $main_url; ?>&delete_slider=<?php echo $option_id ?>" class="btn btn-sm btn-danger slider_delete"><?php _e('Delete'); ?></a>
						</td>
					</tr>

					<?php

					$counter++;
				}
			}else{
				?>

				<tr class="slider_placeholder_row">
					<td colspan="6">
						<div class="slider_placeholder_wrapper" style="border: 5px #dddddd dotted; height: 200px; text-align: center;">
							<div class="slider_placeholder_new"><?php _e('Click here to add new slider'); ?></div>
						</div>
					</td>
				</tr>

				<?php
			}

		}
	}

	if (!function_exists('slider_display')) {

		function slider_display($atts = array())
		{
			ob_start();
			global $wpdb;

			$slider_id = isset($atts['id']) ? $atts['id'] : 0;
			$view_transition = isset($atts['transition']) ? $atts['transition'] : '';
			$view_transition = get_option($view_transition);


			if ($slider_id > 0) {

				$custom_slider = $wpdb->get_row('SELECT option_value FROM ' . $wpdb->prefix . 'options WHERE option_id = ' . esc_sql($slider_id));

				$custom_slider_array = unserialize($custom_slider->option_value);
				$images = array();
				$custom_transtions = '';


				$images_list = $custom_slider_array['images'];
				$transitions_list = $custom_slider_array['transitions'];

				// if(!empty($transitions_list)){
				if (!empty($images_list)) {
					foreach ($images_list as $key => $value) {

						$image_post = get_post($value);
						array_push($images, $image_post->guid);
					}
				}

				if (isset($atts['transition']) && !empty($atts['transition'])) {

					$custom_transtions = $view_transition;
				} else {

					if (!empty($transitions_list)) {
						foreach ($transitions_list as $key => $value) {

							$string = str_replace('\\', '', $value);

							$transition = json_decode($string, true);

							$custom_transtions .= $transition['value'] . ', ';
						}
					}
				}

				include('single-slider.php');

				// } else { echo 'No transition found in this slider!!';}

				?>





	<?php

			}

			$out1 = ob_get_contents();
			ob_end_clean();

			return $out1;
		}
	}

	if(!function_exists('slider_get_new_slider_option_name')){
		function slider_get_new_slider_option_name(){
			global  $wpdb, $gsp_option_name;
			
			
			$gsp_option_query = "SELECT * FROM {$wpdb->prefix}options WHERE option_name LIKE '" . $gsp_option_name . "%'";
			
			//pree($gsp_option_query);exit;

			$get_results = $wpdb->get_results($gsp_option_query, OBJECT);
			
			//pree($get_results);exit;

			if (!empty($get_results)) {

				//if already have some custom slider than get max number slider increment 1 and add new slider option
				$slider_id_array = array();

				

				foreach ($get_results as $key => $value) {
					$option = $value->option_name;
					$array = explode('-', $option);
					array_push($slider_id_array, end($array));
				}


				$max_slider_id = max($slider_id_array);
				$new_slider_id = $max_slider_id + 1;
				$slider_id = $gsp_option_name . $new_slider_id;


			} else {

				//if custom slider not exist than add new slider
				$slider_id = $gsp_option_name . '1';
			}

			return $slider_id;
		}
	}

	if(!function_exists('gsp_slider_update_option_by_id')){
		function gsp_slider_update_option_by_id($option_id, $update_slider_array){

			global $wpdb, $slider_array_default;

			$update_option = $wpdb->get_row('SELECT * FROM ' . $wpdb->prefix . 'options WHERE option_id = ' . esc_sql($option_id));
			if(isset($update_option)){

				$option_data = maybe_unserialize($update_option->option_value);


			}else{

				$option_data = $slider_array_default;

			}

			if(!empty($update_slider_array)){

				foreach ($update_slider_array as $slider_key => $slider_value){
					if(array_key_exists($slider_key, $slider_array_default)){

						$option_data[$slider_key] = $slider_value;

					}
				}
			}

			return update_option($update_option->option_name, $option_data);
		}
	}

	add_action('wp_ajax_gsp_slider_save_data_ajax', 'gsp_slider_save_data_ajax');

	if(!function_exists('gsp_slider_save_data_ajax')){
		function gsp_slider_save_data_ajax(){

			global $slide_transitions_object;

			if(isset($_POST['slider_option_id_ajax'])){
//                pree($_POST);exit;
				$slider_updated = array();

                global $wpdb, $slider_array_default;
				
				
				$update_option_query = 'SELECT * FROM ' . $wpdb->prefix . 'options WHERE option_id = "' . esc_sql(gsp_sanitize_input($_POST['slider_option_id_ajax'])).'"';
				
				//pree($update_option_query);exit;

                $update_option = $wpdb->get_row($update_option_query);
				
                if(!empty($update_option)){

                    $slider_updated = maybe_unserialize($update_option->option_value);


                }else{

                    $slider_updated = array();

                }

				

				$slider_option_id = gsp_sanitize_input($_POST['slider_option_id_ajax']);


				if(isset($_POST['slider_title'])){

				    $slider_updated['slider_title'] = gsp_sanitize_input($_POST['slider_title']);

                }


                if(isset($_POST['slider_transation_id'])){
					
					$slider_transation_id = gsp_sanitize_input($_POST['slider_transation_id']);

                    $selected_transition = $slide_transitions_object[$slider_transation_id];
					//pree($selected_transition);
                    $selected_transition->ID = $slider_transation_id;
					//pree($selected_transition);
                    $transition_value = json_encode($selected_transition);
				    $slider_updated['transitions'] = array($transition_value);


                }

                if(isset($_POST['slider_image'])){

                      $slider_updated['images'] = array_keys(gsp_sanitize_input($_POST['slider_image']));
                }

				$slider_update_status = gsp_slider_update_option_by_id($slider_option_id, $slider_updated);
				
				//pree($slider_option_id);
				//pree($slider_updated);
				//pree($slider_update_status);exit;

                if(!isset($_POST['slider_image'])) {

                    if ($slider_update_status) {
                        $slider_updated['status'] = 'true';
                    } else {
                        $slider_updated['status'] = 'false';
                    }

                    echo json_encode($slider_updated);
                    wp_die();

                }else{


                    slider_get_table_rows_html();
                    wp_die();

                }

			}

		}
	}


	add_action('wp_ajax_slider_add_new_row', 'slider_add_new_row');

	if(!function_exists('slider_add_new_row')){
		function slider_add_new_row(){


			if(isset($_POST['slider_add_new_row'])){

				$new_option_name = slider_get_new_slider_option_name();
				$new_slider_array = array(
					'slider_title' => __('No Title'),
					'transitions' => array(),
					'images' => array(),
				);
				add_option($new_option_name, $new_slider_array);

				slider_get_table_rows_html();



			}

		}
	}

	function gsp_plugin_links($links) { 

		global $gs_premium_link, $gsp_pro;

		$settings_link = '<a href="admin.php?page=gsp_slider">'.__('Settings', 'gulri-slider').'</a>';
		
		if(!$gsp_pro){
			if($gs_premium_link){
				$gs_premium_link = '<a href="'.$gs_premium_link.'" title="'.__('Go Premium', 'gulri-slider').'" target="_blank">'.__('Go Premium', 'gulri-slider').'</a>'; 
		
				array_unshift($links, $settings_link, $gs_premium_link); 
			}else{
				array_unshift($links, $settings_link); 
			}
		}else{
			array_unshift($links, $settings_link); 
		}
	
		return $links; 

	}
