<?php
	$alert_status = false;
    global $wpdb, $gsp_data, $gsp_pro, $gsp_url;
    $main_url = admin_url() . 'admin.php?page=gsp_slider';


    include('slider-transitions.php');
    $slide_transitions_object = json_decode($slide_transitions_json);

    $gsp_option_name = "gsp-item-";
    $display_title_wrapper = 'd-none';
    $button_text = __('Add New Slider');
    $button_class = 'add-new';
    $display_form = 'd-none';
    $required = $slider_tab_class = $display_table = '';


    $edit_title = "";
    $edit_images = array();
    $edit_transitions_ids = array();

    //if preview isset than effect tab data will show
    $selected_slider = 'true';
    $selected_effect = 'false';
    $active_effect = '';
    $active_slider = 'active';

    if (isset($_POST['preview'])) {

        if (
            !isset($_POST['preview_nonce_field'])
            || !wp_verify_nonce($_POST['preview_nonce_field'], 'preview_nonce_action')
        ) {

            _e('Sorry, your nonce did not verify.');
            exit;
        } else {


            $selected_effect = 'true';
            $selected_slider = 'false';
            $active_slider = '';
            $active_effect = 'active';
        }
    }





    //Get Edit Slider
    if (isset($_GET['edit_slider'])) {

        $button_class .= ' d-none';
        $display_table = 'd-none';
        $display_form = '';
        $display_title_wrapper = '';
        $slider_tab_class = 'edit';


        $edit_slider = $_GET['edit_slider'];
        $slider_id = $edit_slider;
        $option_id = $wpdb->get_row('SELECT option_name FROM ' . $wpdb->prefix . 'options WHERE option_id = ' . esc_sql($slider_id));
        if (!empty($option_id) && isset($option_id->option_name)) {


            $edit_slider_array = get_option($option_id->option_name);

            $edit_title = $edit_slider_array['slider_title'];
            $edit_transitions = $edit_slider_array['transitions'];
            $edit_images = $edit_slider_array['images'];
            $images_ids = array_combine($edit_images, $edit_images);



            $edit_transitions_ids = array();
            if (!empty($edit_transitions)) {
                foreach ($edit_transitions as $key => $value) {

                    $edit_string = str_replace('\\', '', $value);
                    $edit_single_transition = json_decode($edit_string, true);
                    array_push($edit_transitions_ids, $edit_single_transition['ID']);
                }
            }
        }
    }


    //GET Delete Slider
    if (isset($_GET['delete_slider'])) {
        $slider_tab_class = 'edit';
        $delete_slider_id = $_GET['delete_slider'];

        $del_option_id = $wpdb->get_row('SELECT option_name FROM ' . $wpdb->prefix . 'options WHERE option_id = ' . esc_sql($delete_slider_id));
        if (!empty($del_option_id) && isset($del_option_id->option_name)) {

            $alert_status = delete_option($del_option_id->option_name);
            $alert_remarks = 'Slider deleted.';
        }
    }

    //Set New Slider title and Transitions
    if (isset($_POST['save_title'])) {

        // pree($_POST);

        if (
            !isset($_POST['slider_form_nonce_field'])
            || !wp_verify_nonce($_POST['slider_form_nonce_field'], 'slider_form_action')
        ) {

            _e('Sorry, your nonce did not verify.');
            exit;
        } else {


            $option_slider_id = gsp_sanitize_input($_POST['slider_id']);

            $get_option = get_option($option_slider_id);

            //pree($get_option);


            $get_option['transitions'] = gsp_sanitize_input($_POST['transitions']);
            $get_option['slider_title'] = gsp_sanitize_input($_POST['slider_title']);

			//pree($option_slider_id);
            //pree($get_option);exit;


            $alert_status = update_option($option_slider_id, $get_option);
            $alert_remarks = __('Slider title & transition updated.');
        }
    }


    //New Slider only with images
    if (isset($_POST['save_images'])) {

        if (
            !isset($_POST['slider_form_nonce_field'])
            || !wp_verify_nonce($_POST['slider_form_nonce_field'], 'slider_form_action')
        ) {

            _e('Sorry, your nonce did not verify.');
            exit;
        } else {

            $display_title_wrapper = '';
            $button_class = 'd-none';
            $display_table = 'd-none';
            $display_form = '';
            $display_title_wrapper = '';
            $required = 'required';

            $new_slider_array = $_POST;

            $new_slider_array = array(
                'slider_title' => __('No Title'),
                'transitions' => array(),
                'images' => gsp_sanitize_input($_POST['images']),
            );

            $get_slider_option = slider_get_new_slider_option_name();
            $alert_remarks = __("Please set a title & transition for this slider.");
            $alert_status = add_option($get_slider_option, $new_slider_array);
            $slider_id = $get_slider_option;

        }
    }



    //update Slider
    if (isset($_POST['update_slider'])) {

        if (
            !isset($_POST['slider_form_nonce_field'])
            || !wp_verify_nonce($_POST['slider_form_nonce_field'], 'slider_form_action')
        ) {

            _e('Sorry, your nonce did not verify.');
            exit;
        } else {

//            pree($_POST);exit;

            $update_slider_id = (isset($_POST['slider_id'])?gsp_sanitize_input($_POST['slider_id']):0);

            $update_slider_array = array(
                'slider_title' => (isset($_POST['slider_title'])?gsp_sanitize_input($_POST['slider_title']):''),
                'transitions' => (isset($_POST['transitions'])?gsp_sanitize_input($_POST['transitions']):''),
                'images' => (isset($_POST['images'])?gsp_sanitize_input($_POST['images']):''),
            );
			
			//pree($update_slider_id);
            //pree($update_slider_array);exit;




            $alert_status = gsp_slider_update_option_by_id($update_slider_id, $update_slider_array);
            $alert_remarks = __('Update successfully.');

            if ($alert_status == true) {

                $edit_title = "";
                $edit_images = array();
                $edit_transitions_ids = array();
            }

            $display_title_wrapper = 'd-none';
            $button_text = __('Add New Slider');
            $button_class = 'add-new';
            $display_form = 'd-none';
            $display_table = '';

        }
    }

    $slider_results = $wpdb->get_results("SELECT * FROM {$wpdb->prefix}options WHERE option_name LIKE '" . $gsp_option_name . "%'", OBJECT);


    ?>




    <div class="container-fluid slider_settings_wrapper">
    
        <span class="main_url" data-url="<?php echo $main_url ?>"></span>

        <div class="row mt-3">
			<div class="col-md-12">
	    		<h3><?php echo $gsp_data['Name'].' '.($gsp_pro?__('Pro', 'gulri-slider'):''); ?> (<?php echo $gsp_data['Version']; ?>) - <?php _e('Settings', 'gulri-slider'); ?> </h3>
			</div>        	
            <div class="col-md-12">

                <nav>
                    <div class="nav nav-tabs" id="nav-tab" role="tablist">
                        <a class="nav-item nav-link <?php echo $active_slider . ' ' . $slider_tab_class ?>" id="nav-slider-tab" data-toggle="tab" href="#nav-settings" role="tab" aria-controls="nav-home" aria-selected="<?php echo $selected_slider ?>"><?php _e('Slider'); ?></a>

                        <a class="nav-item nav-link <?php echo $active_effect ?>" id="nav-effects-tab" data-toggle="tab" href="#nav-effects" role="tab" aria-controls="nav-profile" aria-selected="<?php echo $selected_effect ?>"><?php _e('Effects'); ?></a>


                    </div>
                </nav>

                <div class="tab-content" id="nav-tabContent">

                    <?php

                    if ($alert_status == true) {

                        ?>
                        <div class="alert alert-success alert-dismissible my-3">
                            <a href="#" class="close" data-dismiss="alert" aria-label="close">&times;</a>
                            <strong><?php _e('Success!'); ?></strong> <?php echo $alert_remarks ?>
                        </div>
<script type="text/javascript" language="javascript">

//window.history.replaceState(null, null, "<?php echo $main_url; ?>");
document.location.href = "<?php echo $main_url; ?>";

</script>                        
                        <?php

                    } ?>

                    <div class="alert alert-info images-alert-info d-none my-3">
                        <strong><?php _e('Info!'); ?></strong> <?php _e('Select at least two images for a slider'); ?>
                    </div>

                    <!-- Slider Section Begins -->
                    <div class="tab-pane fade <?php echo ($selected_slider == 'true')?'show active':''; ?>" id="nav-settings" role="tabpanel" aria-labelledby="nav-settings-tab">

                        <div class="mt-3 mb-3">
                            <button class="btn btn btn-sm btn-success <?php echo $button_class ?>" type="button"><?php echo $button_text ?></button>
                        </div>


                        <table class="table slider_table <?php echo $display_table ?>">

                                <thead class="thead-dark">
                                    <tr>
                                        <th scope="col"><?php _e('Slider Title'); ?></th>
                                        <th scope="col"><?php _e('Images'); ?></th>
                                        <th scope="col"><?php _e('Effects'); ?></th>
                                        <th scope="col"><?php _e('Shortcode'); ?></th>
                                        <th scope="col"><?php _e('Action'); ?></th>
                                    </tr>
                                </thead>
                                <tbody class="slider_list_body">

                                <?php slider_get_table_rows_html() ?>


                                </tbody>
                        </table>





                        <div class="slider_form_div <?php echo $display_form ?>">

                            <!-- New Slider Form Begin -->
                            <form method="post" class="slider_form">
                                <?php wp_nonce_field('slider_form_action', 'slider_form_nonce_field'); ?>
                                <div class="title_wrapper <?php echo $display_title_wrapper ?>">
                                    <div class="form-group">
                                        <label for="slider_title"><?php _e('Slider Title'); ?></label>
                                        <input type="text" class="form-control" name="slider_title" value="<?php echo $edit_title ?>" <?php echo $required ?>>
                                        <input type="hidden" name="slider_id" value="<?php echo $slider_id ?>">

                                    </div>


                                    <div class="form-group">
                                        <label for="select_transition"><?php _e('Select Transition'); ?></label>
                                        <select name="transitions[]" class="form-control" id="select_transition"  <?php echo $required ?> size="4">

                                            <?php
                                            if (!empty($slide_transitions_object)) {
                                                $counter = 0;
                                                foreach ($slide_transitions_object as $key => $value) {
                                                    # code...
                                                    $value->ID = $counter;
                                                    $select_value = json_encode($value);
                                                    $disabled = "";
                                                    $selected = "";

                                                    if (in_array($value->ID, $edit_transitions_ids)) {
                                                        $selected = 'selected';
                                                    }

                                                    if ($value->value == 'null') {
                                                        $disabled = 'disabled';
                                                    }
                                                    // echo '<option value="'.$select_value.'" '.$disabled.'>'.$value->key.'</option>';
                                                    echo "<option data-id = '" . $value->ID . "' value='" . $select_value . "' " . $disabled . " " . $selected . ">" . $value->key . "</option>";
                                                    $counter++;
                                                }
                                            }
                                            ?>

                                        </select>
                                    </div>
                                </div>

                                <?php if (!isset($_POST['save_images'])) { ?>

                                    <a class="select_images btn btn btn-sm btn-secondary mb-3 text-white"><?php _e('Select Images'); ?></a>

                                <?php } ?>

                                <div class="mb-3">
                                    <div class="card-header" style="cursor: pointer;">
                                        <?php _e('Select Images'); ?>
                                    </div>
                                    <div class="card-body">
                                        <div class="row selected_images_list">


                                            <?php if ((isset($_POST['save_images']) || isset($_GET['edit_slider']))) {

                                                $images_list = (isset($_POST['images']) && is_array($_POST['images'])?gsp_sanitize_input($_POST['images']):array());

                                                if (isset($_GET['edit_slider'])) {
                                                    $images_list = $edit_images;
                                                }

                                                if (!empty($images_list)) {
                                                    foreach ($images_list as $key => $value) {

                                                        $image_post = get_post($value);


                                                        ?>

                                                        <div class="col-md-2 col-sm-3 col-6 mb-3 ml-0 images_list">

                                                            <!-- <div class="card p-1" style="height:116px">
                                                    <img src="<?php echo $image_post->guid ?>" alt="Card image"
                                                        style="width:100%; height:100%">
                                                </div> -->

                                                            <div class="form-check">
                                                                <input class="form-check-input child-checkbox slider_images_check m-0" data-type="images" name="images[]" type="checkbox" value="<?php echo $image_post->ID ?>" id="img-<?php echo $image_post->ID ?>" checked>
                                                                <label class="form-check-label" for="img-<?php echo $image_post->ID ?>">

                                                                    <div class="card p-1" style="height:116px">
                                                                        <img src="<?php echo $image_post->guid ?>" alt="<?php echo $image_post->post_title ?>" style="width:100%; height:100%">
                                                                    </div>

                                                                </label>
                                                            </div>

                                                        </div>


                                            <?php }
                                                }
                                            } ?>
                                        </div>
                                    </div>
                                </div>



                                <div class="col col-md-2 pl-0">
                                <?php if (isset($_GET['edit_slider'])) { ?>
                                    <button type="submit" class="btn btn btn-sm btn-primary form-control save_images " name="update_slider"><?php _e('Update Slider'); ?></button>

                                <?php } else if (isset($_POST['save_images'])) { ?>

                                    <button type="submit" class="btn btn btn-sm btn-primary form-control save_images" name="save_title"><?php _e('Save Title & Transitions'); ?></button>
                                <?php } ?>

                                <?php if (!isset($_POST['save_images']) && !isset($_GET['edit_slider'])) { ?>
                                    <button type="submit" class="btn btn btn-sm btn-primary form-control save_images " name="save_images" disabled><?php _e('Save Images for Slider'); ?></button>
                                <?php } ?>
                                </div>


                            </form>

                        </div>
<img src="<?php echo $gsp_url; ?>/img/features-banner.png" style="margin:60px auto 0 auto; display:block; max-width:90%" />


                    </div>

                    <!-- Effects Section Begins -->
                    <div class="tab-pane fade <?php if ($selected_effect == 'true') {
                                                    echo 'show active';
                                                } ?>" id="nav-effects" role="tabpanel" aria-labelledby="nav-effects-tab">


                        <form method="post">
                            <?php wp_nonce_field('preview_nonce_action', 'preview_nonce_field'); ?>

                            <div class="row pt-2">
                                <!-- Select Slider for preview -->
                                <div class="col-md-2">
                                    <div class="form-group">

                                        <label for="view_transition"><?php _e('Select Slider'); ?></label>
                                        <select name="view_slider" class="form-control" id="view_slider" style="height:15rem" size="2">
                                            <option value=""><?php _e('Select Slider'); ?></option>
                                            <?php

                                            if (!empty($slider_results)) {
                                                foreach ($slider_results as $key => $value) {
                                                    # code...
                                                    $custom_slider = $value->option_value;
                                                    $custom_slider = unserialize($custom_slider);
                                                    $option_id = $value->option_id;
                                                    $selected_slider = '';

                                                    if (in_array($option_id, $_POST)) {

                                                        $selected_slider = 'selected';
                                                    }

                                                    echo "<option value='" . $option_id . "' " . $selected_slider . ">" . $custom_slider['slider_title'] . "</option>";
                                                }
                                            }
                                            ?>

                                        </select>
                                    </div>
                                </div>

                                <!-- Select Transition for preview -->
                                <div class="col-md-2">
                                    <div class="form-group">
                                        <label for="view_transition"><?php _e('Select Transition'); ?></label>
                                        <select name="view_transition" class="form-control" id="view_transition" style="height:15rem" size="2">

                                            <?php
                                            if (!empty($slide_transitions_object)) {
                                                foreach ($slide_transitions_object as $key => $value) {

                                                    $disabled = "";
                                                    if ($value->value == 'null') {
                                                        $disabled = 'disabled';
                                                    }
                                                    $selected_transition = '';

                                                    if (in_array($value->value, $_POST)) {

                                                        $selected_transition = 'selected';
                                                    }

                                                    echo "<option value='" . $value->value . "' " . $disabled . " " . $selected_transition . ">" . $value->key . "</option>";
                                                }
                                            }
                                            ?>

                                        </select>
                                    </div>
                                </div>

                                <!-- Preview Slider Section -->
                                <div class="col-md-6 p-2">
                                    <?php
                                    if (isset($_POST['preview'])) {
                                        # code...

                                        if (
                                            !isset($_POST['preview_nonce_field'])
                                            || !wp_verify_nonce($_POST['preview_nonce_field'], 'preview_nonce_action')
                                        ) {

                                            _e('Sorry, your nonce did not verify.');
                                            exit;
                                        } else {

                                            $id = gsp_sanitize_input($_POST['view_slider']);
                                            $v_transition = gsp_sanitize_input($_POST['view_transition']);
                                            update_option('temp_transition', $v_transition);


                                            if (!empty($v_transition)) {
                                                $option_transition = 'temp_transition';
                                            }

                                            $short_code = '[GSLIDER id="' . $id . '" transition="' . $option_transition . '"]';

                                            echo do_shortcode($short_code);
                                        }
                                    }
                                    ?>
                                </div>



                            </div>
                            <button type="submit" class="btn btn btn-sm btn-primary" name="preview"><?php _e('Preview Slider'); ?></button>
                        </form>

                    </div>

                </div>
            </div>
        </div>
    </div>